// real_GSL.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "real_GSL.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

#include "real_GSL.h"

char* theLIB = "gsl.dll";


/**********************************************************************
 * real arguments, real results
 **********************************************************************/

double __stdcall
double_wFct_double1(char* fctname, double x1)
{
	double_fct_double1 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);

	if(hLib==NULL) {
		return(error_double);
  }

	tmpfct = (double_fct_double1)GetProcAddress((HMODULE)hLib, fctname);

	if((tmpfct==NULL)) {
		FreeLibrary((HMODULE)hLib);
		return(error_double);
	}

	dummy = tmpfct(x1);

	FreeLibrary((HMODULE)hLib);

	return(dummy);
}

double __stdcall
double_wFct_double2(char* fctname, double x1, double x2)
{
	double_fct_double2 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_double);}

	tmpfct = (double_fct_double2)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_double);}

	dummy = tmpfct(x1,x2);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

double __stdcall
double_wFct_double3(char* fctname, double x1, double x2, double x3)
{
	double_fct_double3 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_double);}

	tmpfct = (double_fct_double3)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_double);}

	dummy = tmpfct(x1,x2,x3);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

double __stdcall
double_wFct_double4(char* fctname, double x1, double x2, double x3, double x4)
{
	double_fct_double4 tmpfct;
	double dummy;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_double);}

	tmpfct = (double_fct_double4)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_double);}

	dummy = tmpfct(x1,x2,x3,x4);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

/**********************************************************************
 * real arguments, results as special function structure
 **********************************************************************/
/*
gsl_sf_result __stdcall
special_wFct_double1(char* fctname, double x1)
{
	gsl_sf_result_fct_double1 tmpfct;
	gsl_sf_result dummy;
	int status;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_special);}

	tmpfct = (gsl_sf_result_fct_double1)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_special);}

	status = tmpfct(x1, &dummy);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
	//return(special_rect(1,2));
}

gsl_sf_result __stdcall
special_wFct_double2(char* fctname, double x1, double x2)
{
	gsl_sf_result_fct_double2 tmpfct;
	gsl_sf_result dummy;
	int status;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_special);}

	tmpfct = (gsl_sf_result_fct_double2)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_special);}

	status = tmpfct(x1,x2, &dummy);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

gsl_sf_result __stdcall
special_wFct_double3(char* fctname, double x1, double x2, double x3)
{
	gsl_sf_result_fct_double3 tmpfct;
	gsl_sf_result dummy;
	int status;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_special);}

	tmpfct = (gsl_sf_result_fct_double3)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_special);}

	status = tmpfct(x1,x2,x3, &dummy);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

gsl_sf_result __stdcall
special_wFct_double4(char* fctname, double x1, double x2, double x3, double x4)
{
	gsl_sf_result_fct_double4 tmpfct;
	gsl_sf_result dummy;
	int status;

	HINSTANCE hLib=LoadLibrary(theLIB);
	if(hLib==NULL) {return(error_special);}

	tmpfct = (gsl_sf_result_fct_double4)GetProcAddress((HMODULE)hLib, fctname);
	if((tmpfct==NULL)) {FreeLibrary((HMODULE)hLib);return(error_special);}

	status = tmpfct(x1,x2,x3,x4, &dummy);
	FreeLibrary((HMODULE)hLib);
	return(dummy);
}

*/