/**********************************************************************
 * complex types
 **********************************************************************/
/*
typedef struct
  {
    double dat[2];
  }
gsl_complex;

#define GSL_REAL(z)     ((z).dat[0])
#define GSL_IMAG(z)     ((z).dat[1])

#define GSL_REAL(z)     ((z).dat[0])
#define GSL_IMAG(z)     ((z).dat[1])
#define GSL_COMPLEX_P(zp) ((zp)->dat)
#define GSL_COMPLEX_P_REAL(zp)  ((zp)->dat[0])
#define GSL_COMPLEX_P_IMAG(zp)  ((zp)->dat[1])

#define GSL_SET_COMPLEX(zp,x,y) do {(zp)->dat[0]=(x); (zp)->dat[1]=(y);} while(0)
#define GSL_SET_REAL(zp,x) do {(zp)->dat[0]=(x);} while(0)
#define GSL_SET_IMAG(zp,y) do {(zp)->dat[1]=(y);} while(0)
*/

// structure for Excel and Maple
/*
typedef struct
{
	double re,im;
}
complex;
*/
// functions to convert the types
//complex     gsl2wrap (gsl_complex z);
//gsl_complex wrap2gsl (complex     z);

/**********************************************************************
 * special functions
 **********************************************************************/

/*
struct gsl_sf_result_struct {
  double val;
  double err;
};

typedef struct gsl_sf_result_struct gsl_sf_result;

#define GSL_SF_RESULT_SET(r,v,e) do { (r)->val=(v); (r)->err=(e); } while(0)


struct gsl_sf_result_e10_struct {
  double val;
  double err;
  int    e10;
};

typedef struct gsl_sf_result_e10_struct gsl_sf_result_e10;
*/

//int gsl_sf_result_smash_e(const gsl_sf_result_e10 * re, gsl_sf_result * r);

/**********************************************************************
 * my function types: GSL has cdecl for export, don not use __stdcall !!
 **********************************************************************/

//#define real double
//#define complexRe double
//#define complexIm double

/* n real arguments, 1 real result */
typedef double (*double_fct_double1)(double);
typedef double (*double_fct_double2)(double,double);
typedef double (*double_fct_double3)(double,double,double);
typedef double (*double_fct_double4)(double,double,double,double);

/* n real arguments, 1 complex result */
/*
typedef complex (*complex_fct_double1)(double);
typedef complex (*complex_fct_double2)(double,double);
typedef complex (*complex_fct_double3)(double,double,double);
typedef complex (*complex_fct_double4)(double,double,double,double);

typedef gsl_complex (*gsl_complex_fct_double1)(double);
typedef gsl_complex (*gsl_complex_fct_double2)(double,double);
typedef gsl_complex (*gsl_complex_fct_double3)(double,double,double);
typedef gsl_complex (*gsl_complex_fct_double4)(double,double,double,double);
*/
/* n complex arguments, 1 real result */
/*
typedef double (*double_fct_complex1)(complex);
typedef double (*double_fct_complex2)(complex,complex);
typedef double (*double_fct_complex3)(complex,complex,complex);
typedef double (*double_fct_complex4)(complex,complex,complex,complex);

typedef double (*double_fct_gsl_complex1)(gsl_complex);
typedef double (*double_fct_gsl_complex2)(gsl_complex,gsl_complex);
typedef double (*double_fct_gsl_complex3)(gsl_complex,gsl_complex,gsl_complex);
typedef double (*double_fct_gsl_complex4)(gsl_complex,gsl_complex,gsl_complex,gsl_complex);
*/
/* n complex arguments, 1 complex result */
/*
typedef complex (*complex_fct_complex1)(complex);
typedef complex (*complex_fct_complex2)(complex,complex);
typedef complex (*complex_fct_complex3)(complex,complex,complex);
typedef complex (*complex_fct_complex4)(complex,complex,complex,complex);

typedef gsl_complex (*gsl_complex_fct_gsl_complex1)(gsl_complex);
typedef gsl_complex (*gsl_complex_fct_gsl_complex2)(gsl_complex,gsl_complex);
typedef gsl_complex (*gsl_complex_fct_gsl_complex3)(gsl_complex,gsl_complex,gsl_complex);
typedef gsl_complex (*gsl_complex_fct_gsl_complex4)(gsl_complex,gsl_complex,gsl_complex,gsl_complex);
*/
/* n real arguments, 1 special function result */
/*
typedef gsl_sf_result (*special_fct_double1)(double);
typedef gsl_sf_result (*special_fct_double2)(double,double);
typedef gsl_sf_result (*special_fct_double3)(double,double,double);
typedef gsl_sf_result (*special_fct_double4)(double,double,double,double);

typedef int (*gsl_sf_result_fct_double1)(double,gsl_sf_result*);
typedef int (*gsl_sf_result_fct_double2)(double,double,gsl_sf_result*);
typedef int (*gsl_sf_result_fct_double3)(double,double,double,gsl_sf_result*);
typedef int (*gsl_sf_result_fct_double4)(double,double,double,double,gsl_sf_result*);
*/
/* n real arguments, 1 special function result incl error message */


//#ifdef HAVE_INLINE
//extern inline complex
//complex_rect (double x, double y)
//{				/* return z = x + i y */
//  complex z;
//  z.re = x;
//	z.im = y;
//  return z;
//}
//#endif

//#ifdef HAVE_INLINE
//extern inline gsl_sf_result
//special_rect (double x, double y)
//{				/* return z = x + i y */
//  gsl_sf_result z;
//	z.val = x;
//	z.err = y;
//  return z;
//}
//#endif

/**********************************************************************
 * my error codes
 **********************************************************************/

#define error_double  9999.9999
//#define error_complex  complex_rect(1e-304,1e-304)
//#define error_special  special_rect(1e-304,1e-304)